// XMP1 (eXperimental Media Player #1).java

import java.awt.BorderLayout;
import java.awt.EventQueue;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.net.URI;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import com.sun.media.jmc.JMediaPane;

public class XMP1 extends JFrame
{
   JMediaPane mp;

   public XMP1 (String mediaURI)
   {
      super ("XMP1: "+mediaURI);
      setDefaultCloseOperation (EXIT_ON_CLOSE);

      try
      {
          mp = new JMediaPane (new URI (mediaURI));
      }
      catch (Exception e)
      {
          System.out.println ("Error opening media: "+e.toString ());
          System.exit (1);
      }

      JPanel panel = new JPanel ();
      panel.setLayout (new BorderLayout ());
      panel.add (mp, BorderLayout.CENTER);
      panel.add (createControlPanel (), BorderLayout.SOUTH);

      setContentPane (panel);

      pack ();
      setVisible (true);
   }

   public JPanel createControlPanel ()
   {
      JPanel panel = new JPanel ();

      JButton btnPlay = new JButton ("Play");
      ActionListener alPlay = new ActionListener ()
                              {
                                  public void actionPerformed (ActionEvent ae)
                                  {
                                     mp.play ();
                                  }
                              };
      btnPlay.addActionListener (alPlay);
      panel.add (btnPlay);

      JButton btnPause = new JButton ("Pause");
      ActionListener alPause = new ActionListener ()
                               {
                                   public void actionPerformed (ActionEvent ae)
                                   {
                                      mp.pause ();
                                   }
                               };
      btnPause.addActionListener (alPause);
      panel.add (btnPause);

      JButton btnStop = new JButton ("Stop");
      ActionListener alStop = new ActionListener ()
                              {
                                  public void actionPerformed (ActionEvent ae)
                                  {
                                     mp.stop ();
                                  }
                              };
      btnStop.addActionListener (alStop);
      panel.add (btnStop);

      JCheckBox cbPAR = new JCheckBox ("Preserve Aspect Ratio", true);
      ChangeListener clPAR = new ChangeListener ()
                             {
                                 public void stateChanged (ChangeEvent ce)
                                 {
                                    JCheckBox cb;
                                    cb = (JCheckBox) ce.getSource ();
                                    mp.setPreserveAspectRatio (cb.isSelected ());
                                 }
                             };
      cbPAR.addChangeListener (clPAR);
      panel.add (cbPAR);

      panel.add (new JLabel ("Duration: "+mp.getDuration ()));

      return panel;
   }

   public static void main (final String [] args)
   {
      if (args.length != 1)
      {
          System.err.println ("usage: java XMP1 mediaURI");
          return;
      }

      Runnable r = new Runnable ()
                   {
                       public void run ()
                       {
                          new XMP1 (args [0]);
                       }
                   };
      EventQueue.invokeLater (r);
   }
}
